/********************************************************************\
*                                                                    *
*  Projekt:   Gordons private library                                *
*  =============================================                     *
*                                                                    *
*  File:      glib.h                                                 *
*                                                                    *
*  Contents:  Some handy gadgets for Gordon                          *
*                                                                    *
*  Comment:                                                          *
*                                                                    *
*  History:                                                          *
*                                                                    *
*  Copyright: 1995, by Gordon Cichon                                 *
*                                                                    *
*  Version  Author    Date    Comment                                *
*  ------- -------- -------- -------------------------------         *
*  0.0      Gordon  01.08.95 I retyped it again.                     *
*                                                                    *
*                                                                    *
0********1*********2*********3*********4*********5*********6*********7*********8
123456789012345678901234567890123456789012345678901234567890123456789012345678*/

#ifndef GLIB_H
#define GLIB_H

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define Case    break;case
#define Default break;default

#define ABS(x)         ((x)>=0?(x):-(x))
#define BTW(x,y,z)     ((x)<(y)?(y):(((x)>(z))?(z):(x)))
#define MIN(x,y)       ((x)<(y)?(x):(y))
#define MAX(x,y)       ((x)>(y)?(x):(y))
#define SQR(x)         ((x)*(x))

#define TRUE           (-1L)
#define FALSE          0L

#endif

