
#include "model.h"

#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <unistd.h>

struct DataPackage model = 
{
    1, 0, 1, 0,
    0.0, 0.0, 0.0, 0.0,
    {
        0, 0,
	0.0, 0.0,
	0.0, 0.0,
	0.0, 0.0,
	0,
	0.0, 0.0, 0.0,
	0.0, 0.0, 0.0,
	{
	    { BC_EIN, 0, 0.0, 0.0 },
	    { BC_EIN, 0, 0.0, 0.0 },
	    { BC_EIN, 0, 0.0, 0.0 },
	    { BC_EIN, 0, 0.0, 0.0 }
	},
	0.0, 0.0
    },
    NULL, NULL, NULL, NULL,
    NULL, NULL, NULL,
    NULL, NULL,
    { 
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL }
    },
    {
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL }
    }, 0,
    0,
    0.0, 0.0, CS_NONE, 50.0, 0.0, 0    
};

struct MasterPackage do_work( struct MasterPackage *pkg )
{
    int s = pkg->s_interface, t = fileno(stdin), tmp;
    char c;
    float tmp2;
    enum FDCMPMessages msg;
    REAL tmp3;
    enum CalculationState state;
    fd_set mask;
    int looping = TRUE;
    
#ifdef VERBOSE 
    while( looping )
    {
        FD_ZERO( &mask );
	FD_SET( s, &mask );
        FD_SET( t, &mask );
        select( FD_SETSIZE, &mask, NULL, NULL, NULL );
	if( FD_ISSET( s, &mask ) )
	{
	    read( s, &c, 1 );
	    printf( "Received: %d (%c)\n", (int)c, c );
	    fflush( stdout );
	}
	if( FD_ISSET( t, &mask ) )
	{
	    scanf( "%d", &tmp );
            if( tmp == -1 )
	    {
		looping = FALSE;
		continue;
	    };
	    c = tmp;
	    write( s, &c, 1 );
	    printf( "Sent: %d (%c)\n", (int) c, c );
	}
    }
#else
    while( (c=getchar()) != 'q' )
    {
	switch( c )
	{
	    case 't':
	       printf( "- time = " );
	       scanf( "%lf", &tmp3 );
	       msg = FDCMPTime;
	       tmp = write( s, &msg, sizeof(msg) );
	       tmp += write( s, &tmp3, sizeof(tmp3) );
	       printf( "- send (%d)\n", tmp );
	       break;
	    case 's':
	       printf( "- state = " );
	       scanf( "%d", &tmp );
	       switch( tmp )
	       {
		   case 0: state = CS_NONE;
		   Case 1: state = CS_BCOND;
		   Case 2: state = CS_SOR;
		   Case 3: state = CS_FLUIDS;
		   Case 4: state = CS_PARTICLES;
	       }
	       msg = FDCMPState;
	       tmp = write( s, &msg, sizeof(msg) );
	       tmp += write( s, &state, sizeof(state) );
	       printf( "- send (%d)\n", tmp );
	       break;
	     case 'p':
	       printf( "- progres = " );
	       scanf( "%d", &tmp );
	       tmp2 = tmp;
	       msg = FDCMPProgres;
	       tmp = write( s, &msg, sizeof(msg) );
	       tmp += write( s, &tmp2, sizeof(tmp2) );
	       printf( "- send (%d)\n", tmp );
	       break;	       
	    case 'r':
	       printf( "- residuum = " );
	       scanf( "%lf", &tmp3 );
	       msg = FDCMPResiduum;
	       tmp = write( s, &msg, sizeof(msg) );
	       tmp += write( s, &tmp3, sizeof(tmp3) );
	       printf( "- send (%d)\n", tmp );
	       break;
	}
    }
    unlink(SOCKET_NAME);
    kill( pkg->pid_interface, SIGKILL );
    exit(0);

#endif
    
    return *pkg;
}

struct MasterPackage *ms_pkg;

