/* surface.h */

#ifndef SURFACE_H
#define SURFACE_H

#ifndef REAL
#define REAL double
#endif

struct particleline;

struct particleline *INIT_PARTICLES
(
    int *N,
    int imax, int jmax,
    REAL delx, REAL dely,
    int ppc, char *problem,
    REAL **U, REAL **V
);

void MARK_CELLS
(
    int **FLAG,
    int imax, int jmax,
    REAL delx, REAL dely,
    int N, struct particleline *Partlines   
);

void SET_UVP_SURFACE
(
    REAL **U, REAL **V,
    REAL **P, int **FLAG,
    int imax, int jmax, 
    REAL Re, 
    REAL delx, REAL dely, REAL delt,
    REAL GX, REAL GY
);

void WRITE_PARTICLES2
(
    char *outputfile,
    int N,
    struct particleline *Particlelines,
    REAL xlength, REAL ylength
);


#endif
